#!/bin/sh
# It is executed the directory of this script as baing current.

LOGOUT=/dev/stdout

. ./update_check_functions
. ./updater-functions

export UPDATE_MP=$1
export UPDATE_TYPE="user"
export TIME=time
export SP=
export PACKAGE_HEADER_SIZE=0
export TMP=/tmp
STDOUT=/dev/stdout
##############################
get_package_info ()
{
	export MTD_INFO="./Info.img"
	# export ENC_KEY=`hexdump -n 16 -v -C ${MTD_INFO} | head -1 | awk '{ print $2$3$4$5$6$7$8$9$10$11$12$13$14$15$16$17 }'`
	# export MODEL=`dd if=${MTD_INFO} of=${STDOUT} bs=16 skip=1 count=1 | sed "s/$/<sep>/g" | sed "s/<sep>//" | sed "s/ //g"`

	export PACKAGE="${UPDATE_MP}/${MODEL} Updater.package"
	export PACKAGE_INFO=${TMP}/SETTING

	UPDATE_NAND_VERSION=`grep -e '^# VERSION' ${PACKAGE_INFO} | awk '{ print $3 }'`
	UPDATE_NAMD_IMAGES=`grep -v '^#' ${PACKAGE_INFO} | grep -v '^UPDATER' | grep -v '^EULA' | awk '{ print $1 }'`
	grep -e '^# No Check NAND Version' ${PACKAGE_INFO} > /dev/null
	if [ $? -eq 0 ];
	then
		UPDATE_NAMD_VNC="yes"
	fi
	if [ "${TIME}" = "time" ];
	then
		echo "  nand VERSION ${UPDATE_NAND_VERSION}"
		echo "  images       ${UPDATE_NAND_IMAGES}"
		echo "  no check     ${UPDATE_NAMD_VNC}"
	fi
}

##############################
get_line_info ()
{
	FILE=`echo "${LINE}" | awk '{ print $1 }'`
	OFFSET=`echo "${LINE}" | awk '{ print $2 }'`
	BLOCK=`echo "${LINE}" | awk '{ print $3 }'`
	CHECKSUM=`echo "${LINE}" | awk '{ print $4" "$5 }'`
	SIZE_ORG=`echo "${LINE}" | awk '{ print $5 }'`
	SIZE=$((((SIZE_ORG + 16) / 16) * 16))
	UPDATE_IV=`echo "${LINE}" | awk '{ print $6 }'`
	SIGNATURE=`echo "${LINE}" | awk '{ print $7 }'`
	UPDATE_APPROACH=`echo "${LINE}" | awk '{ print $8 }' | grep -e 'UA=' | awk -F= '{ print $2 }' | sed -e "s@<sp>@ @g" | sed -e "s@<eq>@=@g"`
	MOUNT_OPT=`echo "${LINE}" | awk '{ print $9 }' | grep -e 'MO=' | awk -F= '{ print $2 }' | sed -e "s@<sp>@ @g" | sed -e "s@<eq>@=@g"`
	REMAIN_WRITE_DATA=`echo "${LINE}" | awk '{ print $10 }' | grep -e 'RW=' | awk -F= '{ print $2 }'`
	# PACKAGE_FILE=`echo "${LINE}" | awk '{ print $11 }' | sed -e "s@<sp>@ @g"`
	PACKAGE_FILE=""
	PACKAGE_HEADER=`echo "${LINE}" | awk '{ print $12 }'`
	PACKAGE_VERSION=`echo "${LINE}" | awk '{ print $13 }'`
	# MTD_PART_NUM=`grep "\"${FILE}\"" /proc/mtd | awk -F: '{ print $1 }' | awk -Fd '{ print $2 }'`
	MTD_PART_NUM=77
	if [ "${PACKAGE_FILE}" = "" ];
	then
		PACKAGE_FILE="${PACKAGE}"
		PACKAGE_HEADER=${HEADER_SIZE}
	fi
	if [ "${PACKAGE_VERSION}" = "" ];
	then
		PACKAGE_VERSION=${UPDATE_NAND_VERSION}
	fi

	echo "### ${FILE}"
	if [ "${TIME}" = "time" ];
	then
		echo "  FILE              ${FILE}"
		echo "  OFFSET            ${OFFSET}"
		echo "  BLOCK             ${BLOCK}"
		echo "  CHECKSUM          ${CHECKSUM}"
		echo "  SIZE_ORG          ${SIZE_ORG}"
		echo "  SIZE              ${SIZE}"
		echo "  UPDATE_IV         ${UPDATE_IV}"
		echo "  SIGNATURE         ${SIGNATURE}"
		echo "  UPDATE_APPROACH   ${UPDATE_APPROACH}"
		echo "  MOUNT_OPT         ${MOUNT_OPT}"
		echo "  REMAIN_WRITE_DATA ${REMAIN_WRITE_DATA}"
		echo "  MTD_PART_NUM      ${MTD_PART_NUM}"
		echo "  PACKAGE_FILE      ${PACKAGE_FILE}"
		echo "  PACKAGE_HEADER    ${PACKAGE_HEADER}"
		echo "  PACKAGE_VERSION   ${PACKAGE_VERSION}"
	fi

	OFFSET=$((OFFSET + PACKAGE_HEADER))
	if [ "${TIME}" = "time" ];
	then
		echo "  add Header OFFSET ${OFFSET}"
	fi
}

##############################
check_nand_package ()
{
	echo "### Check Partitions"
	COUNT=0
	for image in ${UPDATE_NAMD_IMAGES}
	do
		LINE=`grep -e "^${image} " ${PACKAGE_INFO}`
		get_line_info

		if [ "${FILE}" = "" -o \
		     "${OFFSET}" = "" -o \
		     "${BLOCK}" = "" -o \
		     "${CHECKSUM}" = "" -o \
		     "${SIGNATURE}" = "" ];
		then
			echo "Line error" 1
			continue
		fi

		if [ "${FILE}" = "IPL" ];
		then
			MTD_PART_NUM=125
		elif [ "${FILE}" = "SPL" ];
		then
			MTD_PART_NUM=126
		elif [ "${FILE}" = "SDMTable" ];
		then
			MTD_PART_NUM=127
		elif [ "${FILE}" = "Data" -a \
		       "${UPDATE_MP}" = "/Data" -a \
		       "${UPDATE_APPROACH}" = "raw" ];
		then
			echo "  Data partition update skip"
			continue
		else
			if [ "${MTD_PART_NUM}" = "" ];
			then
				echo "Line error" 2
				continue
			fi
			if [ ${MTD_PART_NUM} -le 0 ];
			then
				echo "Partition number error ${MTD_PART_NUM}"
				continue
			fi
		fi

		echo "  Checksum check..."
		if [ ! "${UPDATE_TYPE}" = "service" ];
		then
			echo dd if="${PACKAGE_FILE}" of=${STDOUT} bs=1k skip=${OFFSET} count=${BLOCK} \| head -c ${SIZE} \| openssl aes-128-cbc -d -K ${ENC_KEY} -iv ${UPDATE_IV} \| cksum
			CHECKSUM_TMP=`dd if="${PACKAGE_FILE}" of=${STDOUT} bs=1k skip=${OFFSET} count=${BLOCK} | head -c ${SIZE} | openssl aes-128-cbc -d -K ${ENC_KEY2} -iv ${UPDATE_IV} | cksum`
		else
			CHECKSUM_TMP=`dd if="${PACKAGE_FILE}" of=${STDOUT} bs=1k skip=${OFFSET} count=${BLOCK} | head -c ${SIZE} | openssl aes-128-cbc -d -K ${ENC_KEY2} -iv ${UPDATE_IV} | cksum`
		fi
		if [ "${TIME}" = "time" ];
		then
			echo "  decrypt CHECKSUM  : ${CHECKSUM_TMP}"
		fi
		if [ ! "${CHECKSUM}" = "${CHECKSUM_TMP}" ];
		then
			echo "    checksum error"
			# exit $1
		fi
		if [ ! "${UPDATE_TYPE}" = "service" ];
		then
			echo "    non service update 1"
		fi

		echo "  Signature check..."
		if [ ! "${UPDATE_TYPE}" = "service" ];
		then
			SIGNATURE_TMP=`echo \`dd if="${PACKAGE_FILE}" of=${STDOUT} bs=1k skip=${OFFSET} count=${BLOCK} | head -c ${SIZE} | openssl aes-128-cbc -d -K ${ENC_KEY2} -iv ${UPDATE_IV}  | openssl sha1 -binary | openssl rsautl -sign -inkey ${SIG_KEY} | hexdump -n 512 -v -C | head -n 32 | awk '{ print $2$3$4$5$6$7$8$9$10$11$12$13$14$15$16$17 }'\` | sed 's/ //g'`
		else
			SIGNATURE_TMP=`echo \`dd if="${PACKAGE_FILE}" of=${STDOUT} bs=1k skip=${OFFSET} count=${BLOCK} | head -c ${SIZE} | openssl aes-128-cbc -d -K ${ENC_KEY2} -iv ${UPDATE_IV}  | openssl sha1 -binary | openssl rsautl -sign -inkey ${SIG_KEY} | hexdump -n 512 -v -C | head -n 32 | awk '{ print $2$3$4$5$6$7$8$9$10$11$12$13$14$15$16$17 }'\` | sed 's/ //g'`
		fi
		if [ "${TIME}" = "time" ];
		then
			echo "  decrypt SIGNATURE : ${SIGNATURE_TMP}"
		fi
		if [ ! "${SIGNATURE}" = "${SIGNATURE_TMP}" ];
		then
			echo "    signature error"
			# exit $1
		fi
		if [ ! "${UPDATE_TYPE}" = "service" ];
		then
			echo "    non service update 1"
		fi

		if [ "${FILE}" = "SDMTable" ];
		then
			ADDRESS=`grep -e "^# ${FILE}" ${PACKAGE_INFO} | awk '{ print $3 }'`
			if [ "${TIME}" = "time" ];
			then
				echo "  Address           ${ADDRESS}"
			fi

			if [ ! "${ADDRESS}" = "" ];
			then
				MTD_BLOCK=$(((SIZE_ORG + 1023) / 1024))

				echo "  diff"
				echo "   create /tmp/${FILE}.pac ..."
				${TIME} dd if="${PACKAGE_FILE}" of=${STDOUT} bs=1k skip=${OFFSET} count=${BLOCK} | \
					head -c ${SIZE} | \
					openssl aes-128-cbc -d -K ${ENC_KEY} -iv ${UPDATE_IV} > ${UPDATE_MP}/${FILE}.pac
				ret=$?
				if [ $ret -ne 0 ];
				then
					echo "    Package to tmp error"
					exit $1
				fi

				if [ "${TIME}" = "time" ];
				then
					echo "  read BLOCK        ${MTD_BLOCK}"
				fi

			fi
		fi

		COUNT=$((COUNT + 1))
		if [ "${UPDATE_TYPE}" = "service" ];
		then
			echo "... service update"
		fi
	done

	return ${COUNT}
}

##############################
nand_update ()
{
	echo "### Write Partitions"

	for image in ${UPDATE_NAMD_IMAGES}
	do
		LINE=`grep -e "^${image} " ${PACKAGE_INFO}`
		get_line_info

		if [ "${FILE}" = "" -o \
		     "${OFFSET}" = "" -o \
		     "${BLOCK}" = "" -o \
		     "${CHECKSUM}" = "" -o \
		     "${SIGNATURE}" = "" ];
		then
			echo "Line error" 3
			continue
		fi

		if [ "${FILE}" = "IPL" ];
		then
			MTD_PART_NUM=125
		elif [ "${FILE}" = "SPL" ];
		then
			MTD_PART_NUM=126
		elif [ "${FILE}" = "SDMTable" ];
		then
			MTD_PART_NUM=127
		elif [ "${FILE}" = "Data" -a \
		       "${UPDATE_MP}" = "/Data" -a \
		       "${UPDATE_APPROACH}" = "raw" ];
		then
			echo "  Data partition update skip"
			continue
		else
			if [ "${MTD_PART_NUM}" = "" ];
			then
				echo "Line error" 4
				continue
			fi
			if [ ${MTD_PART_NUM} -le 0 ];
			then
				echo "Partition number error ${MTD_PART_NUM}"
				continue
			fi
		fi

		ADDRESS=`grep -e "^# ${FILE}" ${PACKAGE_INFO} | awk '{ print $3 }'`
		if [ "${TIME}" = "time" ];
		then
			echo "  Address           ${ADDRESS}"
		fi

		dd if="${PACKAGE_FILE}" of=${STDOUT} bs=1k skip=${OFFSET} count=${BLOCK} | \
			head -c ${SIZE} | \
			openssl aes-128-cbc -d -K ${ENC_KEY2} -iv ${UPDATE_IV}  > ${UPDATE_MP}/${FILE}.img
	done

	return 0
}

package_header ()
{
        echo "### MODEL=$MODEL"
	export PACKAGE="${UPDATE_MP}/${MODEL} Updater.package"
        echo "### PACKAGE=$PACKAGE"
	export PACKAGE_INFO=${TMP}/SETTING

	unpack_package_info "${PACKAGE}" "${PACKAGE_INFO}" 0 "yes"
	if [ $? -ne 0 ];
	then
		END_STATE=${STATE_PACKAGE_NG}
		exit 1
	fi

	export HEADER_SIZE=${PACKAGE_HEADER_SIZE}
}

##############################
# Main
##############################

if [ $# -ne 1 -o ! -d $1 ]
then
  echo "usage: $0 <upd_dir>"
  exit 1
fi

get_info_key
package_header
get_package_info

check_nand_package 1

nand_update

exit 0
